/* 
 * JAC - Just Another Cdplayer
 * Release: 0.1.0
 * Copyleft (c) 1999 by Cosimo Vagarini - vaga@dada.it
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * (See the included file COPYING)
 */
#include <string.h>
#include <stdio.h> 
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include "jac.h"
#include "jac_cmd.h"
#include "jac_console.h"
#include "jac_cddb.h"
#include "jac_func.h"
#include "jac_lang.h"
#include "jac_cfg.h"
#include "jac_dbres.h"

int main(int argc, char *argv[])
{
	int i,x,vol,last,ntrack,repeat,cd_fd,nopt,prtdiscid;
	int arr_track[MAXTRACK];
	int stp,inf,ply,par,vlm,rnd,jmp,crz,ncrazy,cddb,cdi;
	int back,straight,setdef,ej;
	char *defopt[30];
	char *strdef=malloc(255);
	char *strtemp=NULL;
	char *tempseq=NULL;
	char *tempexc=NULL;

	int ch;
	extern char *optarg;
	extern int optind, opterr, optopt;
	struct option longopts[] = {
		{"help",		0,	0,	'h'},
		{"kill",		0,	0,	'k'},
		{"detailed-info",	0,	0,	'i'},
		{"info",		0,	0,	'I'},
		{"pause",		0,	0,	'f'},
		{"repeat",		0,	0,	'r'},
		{"last-to-first",	0,	0,	'b'},
		{"eject",		0,	0,	'e'},
		{"random-order",	0,	0,	'c'},
		{"console",		0,	0,	'o'},
		{"set-as-cd-default",	0,	0,	'D'},
		{"discid",		0,	0,	'd'},
		{"cddb",		0,	0,	'C'},
		{"cdindex",		0,	0,	'X'},
		{"version",		0,	0,	'V'},
		{"volume",		1,	0,	'v'},
		{"play-track",		1,	0,	'p'},
		{"this-to-first",	1,	0,	'B'},
		{"this-to-last",	1,	0,	'P'},
		{"play-list",		1,	0,	'm'},
		{"exclude",		1,	0,	'x'},
		{"skip-forward",	1,	0,	's'},
		{"skip-back",		1,	0,	'S'},
		{"cdrom-device",	1,	0,	'w'},
		{"mixer-device",	1,	0,	'a'},
		{"crazy",		1,	0,	'z'},
		{0,			0,	0,	0  },
	};
	 
	for (i=0;i<30;i++) {	
		defopt[i]=malloc(255);
		memset(defopt[i],0,255);
	}
	srand((int) getpid());

	stp=inf=ply=par=vlm=rnd=jmp=vol=ncrazy=0;
	crz=repeat=nopt=cdi=cddb=prtdiscid=ntrack=0;
	back=straight=setdef=ej=0;

	devcdrom=malloc(256);
	devmixer=malloc(256);
	dircddb=malloc(256);
	strcpy(devcdrom,DEFCDROM);
	strcpy(devmixer,DEFMIXER);
	sprintf(dircddb, "%s/.jac", getenv("HOME"));
	nopt=getcfg(devcdrom,devmixer,dircddb,defopt,strdef);

	/* Use configuration file options only if no option is given
	 * on command line */
	if (argc>1) {
		for (i=0;i<argc;i++)
			strcpy(defopt[i],argv[i]);
		nopt=argc;
	} else {
		fprintf(stdout,"%s%s ",USEDEF,strdef);
		for (i=1;i<nopt;i++)
			fprintf(stdout,"%s ",defopt[i]);
		fprintf(stdout,"\n");
	}

	if (nopt==1)
 		ply=1; 


	while ((ch = getopt_long(nopt, defopt, "hekriIocfdbDCXVv:p:B:P:m:x:s:S:w:a:z:", longopts, 0)) != EOF) {
		switch (ch) {
		case 'h':
			uso();
			return 0;
			break;
		case 'e':
			ej=1;
			break;
		case 'k':
			stp=1;
			break;
		case 'r':
			repeat=1;
			ply=1;
			break;
		case 'i':
			inf=2;
			break;
		case 'I':
			inf=1;
			break;
		case 'o':
			console=1;
			ply=1;
			break;
		case 'c':
			rnd=1;
			ply=1;
			break;
		case 'f':
			par=1;
			break;
		case 'd':
			prtdiscid=1;
			break;
		case 'C':
			cddb=1;
			break;
		case 'X':
			cdi=1;
			break;
		case 'b':
			back=1;
			ply=1;
			break;
		case 'V':
			show_version();
			break;
		case 'D':
			setdef=1;
			break;
		case 'v':
			strtemp=strdup(optarg);
			vol=getnum(strtemp);
			if (vol>=0 && vol<=128) 
				vlm=1;				
			free(strtemp);
			break;
		case 'p':
			strtemp=strdup(optarg);
			ntrack=getnum(strtemp);
			free(strtemp);
			break;
		case 'B':
			strtemp=strdup(optarg);
			ntrack=getnum(strtemp);
			back=1;
			free(strtemp);
			break;
		case 'P':
			strtemp=strdup(optarg);
			ntrack=getnum(strtemp);
			straight=1;
			free(strtemp);
			break;
		case 'm':
			tempseq=strdup(optarg);
			break;
		case 'x':		
			tempexc=strdup(optarg);
			break;
		case 's':
			strtemp=strdup(optarg);
			jmp=getnum(strtemp);
			free(strtemp);
			break;
		case 'S':
			strtemp=strdup(optarg);
			jmp=getnum(strtemp);
			jmp=-jmp;
			free(strtemp);
			break;
		case 'w':
			free(devcdrom);
			devcdrom=strdup(optarg);
			break;
		case 'a':
			free(devmixer);
			devmixer=strdup(optarg);
			break;
		case 'z':
			strtemp=strdup(optarg);
			ncrazy=getnum(strtemp);
			ncrazy=ncrazy/5*5;
			ncrazy=ncrazy==0 ? 30 : ncrazy;
			ncrazy=ncrazy>300 ? 300 : ncrazy;
			fprintf(stderr,"Crazy=%d\n",ncrazy);
			crz=1;
			free(strtemp);
			break;
		default:
			uso();
			return 0;
			break;

		}
	}

	

	/* Arrange track list */
	
	cd_fd = cd_open (devcdrom,0);
	last=last_track(cd_fd);
	for (i=0;i<last;i++)
		arr_track[i]=i+1;
	arr_track[last]=0;

	if (ej) {
		eject(cd_fd);
		return 0;
	}

	if (setdef) 
		setdefault(defopt,last,cd_fd,nopt);


	if (back && ntrack) {
		if (ntrack>0 && ntrack<=last) {
			for (x=0;x<ntrack;x++)
 				arr_track[x]=ntrack-x;

			for (x=ntrack;x<last;x++)
				arr_track[x]=0;

			ply=1;
		} else
			outofbounds(last);
	}
	
	if (back && !ntrack) {
		for (x=0;x<last;x++)
			arr_track[x]=last-x;
		arr_track[last]=0;
	}
	
	if (ntrack && !back && !straight) {
		if (ntrack>0 && ntrack<=last) {
  			arr_track[0]=ntrack;
  			arr_track[1]=0;
			ply=1;
		} 
		else
			outofbounds(last);
	}	

	if (ntrack && straight) {
		if (ntrack>0 && ntrack<=last) {
			for (x=0;x<(last-ntrack)+1;x++)
				arr_track[x]=ntrack+x;
			for (x=(last-ntrack)+1;x<last;x++)
				arr_track[x]=0;
			ply=1;
		} else
			outofbounds(last);
	}

	if (tempseq) {
		getseq(tempseq,arr_track,last,0,1);
		if (arr_track[0]==0) {
			fprintf(stderr,ERRSEQ);
			exit(1);
		} else
			ply=1;
	}

	if (tempexc) {
		getseq(tempexc,arr_track,last,0,0);
		if (arr_track[0]==0) {
			fprintf(stderr,ERRSEQ);
			exit(1);
		} else
			ply=1;
	}

	if (jmp) {
		if (jmp > last)
			jmp=0;
	}
		

	/* End track list arrangement */
	

	if (console) {
		jacconsole(cd_fd,arr_track);
		exit(0); 
	}

	if (!console && (ply || crz)) {
		switch (fork()) {
			case -1: /* fork() error */
				fprintf(stderr,ERRFORK);
				exit(1);
			case  0: /* child context */
				break;
			default: /* parent context */
				exit(0);
		}
	}

	if (cddb) {
		i=jac_cddb(cd_fd);
		if (i)
			fprintf(stderr,"jac::CDDB Result: %s\n",cddb_tbl_result[-i]);
	}

	if (cdi) {
		i=jac_cdi(last,cd_fd);
		if (i)
			fprintf(stderr,"jac::CdIndex Result: %s\n",cdi_tbl_result[-i]);
	}

	if (inf)
	  geninfo(cd_fd,inf,ply);

	if (vlm)
		set_volume(vol);

	if (stp)
		stop(cd_fd);

	if (par)
		pause_resume(cd_fd);

	if (rnd)
		randsort(arr_track);

	if (jmp)
		jump(cd_fd,jmp,arr_track);

	if (crz)
		crazyplay(cd_fd,arr_track,ncrazy);

	if (ply)              
		playlist(repeat,cd_fd,arr_track);

	if (prtdiscid) {
		fprintf(stdout,"CDDB    Disc ID: %08lx\n",cddb_discid(last,cd_fd));
		fprintf(stdout,"CDIndex Disc ID: %s\n",cdi_discid(last,cd_fd));
	}

	/* The End */
	return 0;
}

/* End of jac.c */
