#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <pwd.h>
#include "jac_cmd.h"
#include "jac_cddb.h"


struct toc {
	int min;
	int sec;
	int frame;
};

struct toc cdtoc[100];

int cddb_sum(int n)
{
	char buf[12], *p;
	int  ret = 0;

	sprintf(buf, "%u", n);
	for (p = buf; *p != '\0'; p++)
		ret += (*p - '0');

	return ret;
}

unsigned long cddb_discid(int tot_trks,int cd_fd)
{
	int i=0,t=0,n=0;
	cd *hw=cd_init(cd_fd);

	for( i=0; i <= tot_trks+1; i++ ) {
		cdtoc[i].frame = hw->tocent[i].cdte_addr.msf.frame;
		cdtoc[i].min = hw->tocent[i].cdte_addr.msf.minute;
		cdtoc[i].sec = hw->tocent[i].cdte_addr.msf.second;
	}

	for (i = 0; i < tot_trks; i++) {
		n += cddb_sum((cdtoc[i].min * 60) + cdtoc[i].sec);
		t +=((cdtoc[i+1].min * 60) + cdtoc[i+1].sec) -
			((cdtoc[i].min * 60) + cdtoc[i].sec);
	}

	return ((n % 0xff) << 24 | t << 8 | tot_trks);
}


int gsock(char *s, int size, int socket )
{
	int i=0, r;
	char c;
	i=0;
    
	while( (r=recv(socket, &c, 1, 0)) != 0 ) {
		if(c == '\r' || c == '\n')
			break;
		if( i > size )
			break;
		s[i] = c;
		i++;
	}
	s[i] = 0;
	recv(socket, &c, 1, 0 ); 
	if( r < 0 )
		return -1;
	return r;
}

static char *iftok(char *p, const char *p2)
{
  p=strtok(p,p2);
  if(p==NULL)
    return("????");
  return p;
}

void gettitle(int last, int cd_fd,char *title)
{
	FILE *fcddb;
	char nomfil[101];
	char tmp[101];

	sprintf(nomfil,"%s/%08lx",dircddb,cddb_discid(last,cd_fd));
	fcddb=fopen(nomfil,"r");
	if (fcddb==NULL) {
		strcpy(title,"*no title available*");
	} else {
		while(fgets(tmp,80,fcddb)!=NULL) {
			tmp[strlen(tmp)-1] = 0;
			if(strncmp(tmp,"DTITLE",6)==0) {
				strcpy(title,tmp+7);
				break;    
			}
		}
	}
}

void agglist(int last,int cd_fd)
{
	FILE *lista;
	char nomlista[101];
	char *title=malloc(150);
	char *tmp=malloc(255);

	memset(title,0,100);
	sprintf(nomlista,"%s/cddblist",dircddb);
	lista=fopen(nomlista,"a");
	if (lista!=NULL) {
		gettitle(last,cd_fd,title);
		snprintf(tmp,255,"Disc ID: %08lx - Title: %s\n",cddb_discid(last,cd_fd),title);
		fputs(tmp,lista);
		fclose(lista);
	}
}

int jac_cddb(int cd_fd)
{
	int sck,code,qcode,port,sersock;
	struct sockaddr_in *addr;
	struct hostent *he;
	char hostname[80];
	char s[512];
	char server[50],qcateg[20],qdiscid[10];
	struct passwd* pwd;
	char tmp[10],buf[200];
	int i, n,l,last,b=200;
	cd *hw = cd_init(cd_fd);
	FILE *outfile;
	FILE *fcddb;

	last=hw->tochdr.cdth_trk1;

	sprintf(buf,"%s/%08lx",dircddb,cddb_discid(last,cd_fd));
	fcddb=fopen(buf,"r");
	if (fcddb!=NULL) {
		fclose(fcddb);
		return 0;
	}

	gethostname(hostname,80);

	if (strcmp(hostname,"")==0)
		strcpy(hostname,"localhost");
	pwd=getpwuid(getuid());
	if (pwd==NULL)
		strcpy(pwd->pw_name,"utonto");

	if (strcmp(pwd->pw_name,"")==0)
		strcpy(pwd->pw_name,"utonto");
		
	strcpy(server,"cddb.cddb.com");
	port=888;
	
	he=malloc(sizeof(struct hostent));
	if ((he=gethostbyname(server))==NULL)
		return -1;
	if ((sck=socket(AF_INET,SOCK_STREAM,0))==-1)
		return -2;

	addr=(struct sockaddr_in *) malloc(sizeof(struct sockaddr_in));
	addr->sin_family=AF_INET;
	addr->sin_port=htons(port);
	addr->sin_addr= *((struct in_addr *)he->h_addr);
	bzero(&(addr->sin_zero), 8);
	if (connect(sck, (struct sockaddr *) addr,sizeof(struct sockaddr))==-1) 
		return -3;
	
	sersock=sck;
	
	gsock(s,80,sersock);
	if (sscanf(s,"%d",&code)!=1)
		return -4;
		
	if (code!=200 && code!=201)
		return -5;

	snprintf(s,512,"cddb hello %s %s %s %s\n",pwd->pw_name,hostname,"jac","0.9");
	send(sersock,s,strlen(s),0);
	gsock(s,80,sersock);	

	if (sscanf(s,"%d",&code)!=1)
		return -6;
		
	if (code!=200 && code!=201)
		return -7;
		
	sprintf( buf, "cddb query %08lx %d ",cddb_discid(last,cd_fd),last);
	for(i=0;i<last;i++) {
		int min, sec;
		min = hw->tocent[i].cdte_addr.msf.minute;
		sec = hw->tocent[i].cdte_addr.msf.second;
		n=(min*60)+sec;
		l=sprintf( tmp, "%u ",(n*75)+hw->tocent[i].cdte_addr.msf.frame);

		if(b>=l) {
			strcat( buf, tmp );
			b-=l;
		}
	}
	l=sprintf( tmp, "%i\n", (hw->tocent[last].cdte_addr.msf.minute*60)
				+(hw->tocent[last].cdte_addr.msf.second));
	if(b>=l)
		strcat( buf,tmp );   

	send(sersock,buf,strlen(buf),0);
	gsock(s,511,sersock);
	s[511]=0;
	if (sscanf(s,"%d",&code)!=1)
		return -8;
	if (code!=200 && code!=201)
		return -9;

	
	qcode = atoi(strtok( s, " " ));
	strncpy(qcateg, iftok(NULL, " ") , 20);
	qcateg[19]=0;
	strncpy(qdiscid, iftok( NULL, " "), 10);
	qdiscid[9]=0;

	sprintf( buf, "cddb read %s %s\n", qcateg, qdiscid );
	send(sersock,buf,strlen(buf),0);

	sprintf( buf, "%s/%s", dircddb,qdiscid );

	outfile = fopen( buf, "w" );
	do {
		gsock(s,80,sersock);
		fprintf( outfile, "%s\n", s );
	} while( strcmp( ".", s ) );
	fclose(outfile);
	close(sersock);
	agglist(last,cd_fd);
	return 0;	
}

