#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include "jac_lang.h"
#include "jac.h"
#include "jac_cddb.h"
#include "jac_cmd.h"

void cutnl(char *s)
{
	if (*(s+strlen(s)-1)=='\n')
		*(s+strlen(s)-1)='\0';
}


int splitopt(char *s,char *a[])
{
	int i;
	int a1=1;
	strcpy(a[0],"jac");

	for (i=0;i<strlen(s);i++) {
		if (isspace(s[i])) {
			if (strlen(a[a1])>0)
				a1++;
		} else strncat(a[a1],(s+i),1);
	}
	return a1;
}

int creaconfig(char *f)
{
	char *dir=malloc(255);
	FILE *fp;
	struct stat st;
	snprintf(dir,255,"%s/.jac/",getenv("HOME"));
	if (stat(dir,&st)<0) {
		if (errno==ENOENT) {
			if (mkdir(dir,S_IRWXU))
				return -1;
		} else return -1;
	}
	fp=fopen(f,"w");
	if (fp==NULL)
		return -1;
	fprintf(fp,DEFCFG);
	fclose(fp);
	return 0;
}
/* Read Data from CFG file */
int getcfg(char *dcdrom,char *dmixer,char *dcddb,char *defopt[],char *def)
{
	FILE *fp;
	char *fcfg=malloc(100);
	char *buff=malloc(200);
	char *stropt=malloc(300);
	char *dscopt=malloc(300);
	char *sdisc=malloc(9);
	int nopt=0;
	int cd_fd,last,res;
	memset(sdisc,0,9);
	snprintf(fcfg,100,"%s%s",getenv("HOME"),FILECFG);
	strcpy(stropt,"jac ");
	fp=fopen(fcfg,"r");
	if (fp==NULL) {
		fprintf(stdout,ERRNOCFG,fcfg);
		res=creaconfig(fcfg);
		if (res)
			fprintf(stdout,"Errors while creating .jac dir!");
		return 0;
	}

	while (fgets(buff,400,fp)!=NULL) {
		buff[strlen(buff)-1]=0;

		if (strncmp(buff,"cdrom=",6)==0) {
			strncpy(dcdrom,(buff+6),255);
			cutnl(dcdrom);
			cd_fd=cd_open (dcdrom,1);
			if (cd_fd) {
				last=last_track(cd_fd);
				snprintf(sdisc,9,"%08lx",cddb_discid(last,cd_fd));
				cd_close(cd_fd);
			}
			continue;
		}
		if (strncmp(buff,"mixer=",6)==0) {
			strncpy(dmixer,(buff+6),255);
			continue;
		}
		if (strncmp(buff,"cddbdir=",8)==0) {
			strncpy(dcddb,(buff+8),255);
			continue;
		}
		if (strncmp(buff,"defopt=",7)==0) {
			strncat(stropt,(buff+7),255);
			continue;
		}
		if (*sdisc && (strncmp(buff,sdisc,8)==0)) {
			strncpy(dscopt,(buff+9),255);
			continue;
		}
	}
	cutnl(dmixer);
	cutnl(dcddb);
	if (strcmp(dcddb+strlen(dcddb)-1,"/")==0)
		*(dcddb+strlen(dcddb)-1)=0;

	if (*dscopt) {
		strcpy(stropt,dscopt);
		snprintf(def,255," (Disc ID:%s) : ",sdisc);
	}
	else strcpy(def,": ");

	nopt=splitopt(stropt,defopt);
	fclose(fp);
	return nopt;
}


